var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import React, { useContext, Children, useState, useRef, useLayoutEffect, useEffect, useMemo, useCallback } from "react";
const KEY = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var PLACEHOLDER = /* @__PURE__ */ ((PLACEHOLDER2) => {
  PLACEHOLDER2["Id"] = "__id__";
  PLACEHOLDER2["Value"] = "__value__";
  return PLACEHOLDER2;
})(PLACEHOLDER || {});
const DefaultClass = "marked-input";
const markupToRegex = (markup) => {
  const escapedMarkup = escapeRegex(markup);
  const charAfterDisplay = markup[markup.indexOf(PLACEHOLDER.Value) + PLACEHOLDER.Value.length];
  const charAfterId = markup[markup.indexOf(PLACEHOLDER.Id) + PLACEHOLDER.Id.length];
  return new RegExp(escapedMarkup.replace(PLACEHOLDER.Value, `([^${escapeRegex(charAfterDisplay || "")}]+?)`).replace(PLACEHOLDER.Id, `([^${escapeRegex(charAfterId || "")}]+?)`));
};
const makeMentionsMarkup = (markup, id, value) => {
  return markup.replace(PLACEHOLDER.Id, id).replace(PLACEHOLDER.Value, value);
};
const escapeRegex = (str) => str.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function toString(values, configs) {
  let result = "";
  for (let value of values) {
    result += isObject(value) ? makeMentionsMarkup(configs[value.childIndex].markup, value.id, value.value) : value;
  }
  return result;
}
const genHash = (str, seed = 0) => {
  let h1 = 3735928559 ^ seed, h2 = 1103547991 ^ seed;
  for (let i = 0, ch; i < str.length; i++) {
    ch = str.charCodeAt(i);
    h1 = Math.imul(h1 ^ ch, 2654435761);
    h2 = Math.imul(h2 ^ ch, 1597334677);
  }
  h1 = Math.imul(h1 ^ h1 >>> 16, 2246822507) ^ Math.imul(h2 ^ h2 >>> 13, 3266489909);
  h2 = Math.imul(h2 ^ h2 >>> 16, 2246822507) ^ Math.imul(h1 ^ h1 >>> 13, 3266489909);
  return 4294967296 * (2097151 & h2) + (h1 >>> 0);
};
const isObject = (value) => typeof value === "object";
function extractConfigs(children) {
  return Children.map(children, (child) => child.props);
}
const createContext = (name) => {
  const context = React.createContext(void 0);
  context.displayName = name;
  const hook = createContextHook(context);
  const provider = createProvider(context);
  return [hook, provider];
  function createContextHook(context2) {
    return () => {
      const value = useContext(context2);
      if (value)
        return value;
      throw new Error(`The context ${context2.displayName} didn't found!`);
    };
  }
  function createProvider(context2) {
    let value = context2;
    return value.Provider;
  }
};
const [useStore, StoreProvider] = createContext("MarkedInputStoreProvider");
var Type = /* @__PURE__ */ ((Type2) => {
  Type2[Type2["Change"] = 0] = "Change";
  Type2[Type2["Delete"] = 1] = "Delete";
  return Type2;
})(Type || {});
const useCaret = () => useState(() => new Caret())[0];
class Caret {
  constructor(_position = NaN) {
    this._position = _position;
  }
  get isBlurred() {
    return Number.isNaN(this._position);
  }
  clear() {
    this._position = NaN;
  }
  static setIndex(offset) {
    const selection = window.getSelection();
    if (!(selection == null ? void 0 : selection.anchorNode) || !selection.rangeCount)
      return;
    const range = selection.getRangeAt(0);
    range == null ? void 0 : range.setStart(range.startContainer.firstChild || range.startContainer, offset);
    range == null ? void 0 : range.setEnd(range.startContainer.firstChild || range.startContainer, offset);
  }
  static getIndex() {
    var _a;
    const selection = window.getSelection();
    return (_a = selection == null ? void 0 : selection.anchorOffset) != null ? _a : NaN;
  }
  saveRightOffset() {
    var _a, _b;
    const selection = window.getSelection();
    const position = (_b = (_a = selection == null ? void 0 : selection.anchorNode) == null ? void 0 : _a.textContent) == null ? void 0 : _b.length;
    this._position = position != null ? position : NaN;
  }
  restoreRightOffset() {
    var _a, _b, _c;
    if (this.isBlurred)
      return;
    const selection = window.getSelection();
    const range = (selection == null ? void 0 : selection.rangeCount) ? selection.getRangeAt(0) : null;
    if (!(selection == null ? void 0 : selection.anchorNode))
      return;
    let offset = ((_c = (_b = (_a = selection == null ? void 0 : selection.anchorNode) == null ? void 0 : _a.textContent) == null ? void 0 : _b.length) != null ? _c : 0) - this._position;
    range == null ? void 0 : range.setStart(selection.anchorNode, offset);
    range == null ? void 0 : range.setEnd(selection.anchorNode, offset);
    this.clear();
  }
  static getCaretIndex(element) {
    let position = 0;
    const selection = window.getSelection();
    if (!(selection == null ? void 0 : selection.rangeCount))
      return position;
    const range = selection.getRangeAt(0);
    const preCaretRange = range.cloneRange();
    preCaretRange.selectNodeContents(element);
    preCaretRange.setEnd(range.endContainer, range.endOffset);
    position = preCaretRange.toString().length;
    return position;
  }
  static setCaretToEnd(element) {
    const selection = window.getSelection();
    selection == null ? void 0 : selection.setPosition(element, 1);
  }
  setCaretRightTo(element, offset) {
    const selection = window.getSelection();
    const range = selection == null ? void 0 : selection.getRangeAt(0);
    range == null ? void 0 : range.setStart(range.endContainer, offset);
    range == null ? void 0 : range.setEnd(range.endContainer, offset);
  }
}
const useHandleKeyDown = () => {
  const { dispatch, caret, sliceMap, focus } = useStore();
  const keys = [...sliceMap.keys()];
  const handleKeyDown = (event) => {
    var _a, _b;
    const target = event.target;
    const caretIndex = Caret.getCaretIndex(target);
    const isStartCaret = caretIndex === 0;
    const isEndCaret = caretIndex === ((_a = target.textContent) == null ? void 0 : _a.length);
    const handleMap = {
      [KEY.LEFT]: isStartCaret ? handlePressLeft : null,
      [KEY.RIGHT]: isEndCaret ? handlePressRight : null,
      [KEY.UP]: null,
      [KEY.DOWN]: null,
      [KEY.DELETE]: null,
      [KEY.BACKSPACE]: isStartCaret ? handlePressBackspace : null
    };
    (_b = handleMap[event.key]) == null ? void 0 : _b.call(handleMap);
  };
  function handlePressLeft() {
    if (focus.focused != null) {
      let index = keys.indexOf(focus.focused);
      if (index >= 2) {
        focus.setFocused(keys[index - 2]);
        focus.isTail.current = true;
      }
    }
  }
  function handlePressRight() {
    if (focus.focused != null) {
      let index = keys.indexOf(focus.focused);
      if (keys.length - index > 2) {
        focus.setFocused(keys[index + 2]);
        focus.isTail.current = false;
      }
    }
  }
  function handlePressBackspace() {
    if (focus.focused != null) {
      let index = keys.indexOf(focus.focused);
      if (index >= 1) {
        caret.saveRightOffset();
        dispatch(Type.Delete, { key: keys[index - 1] });
      }
    }
  }
  return handleKeyDown;
};
const useHeldCaret = (ref) => {
  const index = useRef(NaN);
  function update() {
    if (!ref.current)
      return;
    index.current = Caret.getCaretIndex(ref.current);
  }
  function restore() {
    if (!ref.current)
      return;
    Caret.setIndex(index.current);
    index.current = NaN;
  }
  useLayoutEffect(() => {
    if (Number.isNaN(index.current))
      return;
    restore();
  });
  return update;
};
const useRestoredFocus = (caret, ref) => {
  useEffect(() => {
    var _a;
    if (caret.isBlurred)
      return;
    (_a = ref.current) == null ? void 0 : _a.focus();
    caret.restoreRightOffset();
  }, []);
};
var jsxRuntime = { exports: {} };
var reactJsxRuntime_production_min = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;
function toObject(val) {
  if (val === null || val === void 0) {
    throw new TypeError("Object.assign cannot be called with null or undefined");
  }
  return Object(val);
}
function shouldUseNative() {
  try {
    if (!Object.assign) {
      return false;
    }
    var test1 = new String("abc");
    test1[5] = "de";
    if (Object.getOwnPropertyNames(test1)[0] === "5") {
      return false;
    }
    var test2 = {};
    for (var i = 0; i < 10; i++) {
      test2["_" + String.fromCharCode(i)] = i;
    }
    var order2 = Object.getOwnPropertyNames(test2).map(function(n2) {
      return test2[n2];
    });
    if (order2.join("") !== "0123456789") {
      return false;
    }
    var test3 = {};
    "abcdefghijklmnopqrst".split("").forEach(function(letter) {
      test3[letter] = letter;
    });
    if (Object.keys(Object.assign({}, test3)).join("") !== "abcdefghijklmnopqrst") {
      return false;
    }
    return true;
  } catch (err) {
    return false;
  }
}
shouldUseNative() ? Object.assign : function(target, source) {
  var from;
  var to = toObject(target);
  var symbols;
  for (var s = 1; s < arguments.length; s++) {
    from = Object(arguments[s]);
    for (var key in from) {
      if (hasOwnProperty.call(from, key)) {
        to[key] = from[key];
      }
    }
    if (getOwnPropertySymbols) {
      symbols = getOwnPropertySymbols(from);
      for (var i = 0; i < symbols.length; i++) {
        if (propIsEnumerable.call(from, symbols[i])) {
          to[symbols[i]] = from[symbols[i]];
        }
      }
    }
  }
  return to;
};
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f = React, g = 60103;
reactJsxRuntime_production_min.Fragment = 60107;
if (typeof Symbol === "function" && Symbol.for) {
  var h = Symbol.for;
  g = h("react.element");
  reactJsxRuntime_production_min.Fragment = h("react.fragment");
}
var m = f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, n = Object.prototype.hasOwnProperty, p = { key: true, ref: true, __self: true, __source: true };
function q(c, a, k) {
  var b, d = {}, e = null, l = null;
  k !== void 0 && (e = "" + k);
  a.key !== void 0 && (e = "" + a.key);
  a.ref !== void 0 && (l = a.ref);
  for (b in a)
    n.call(a, b) && !p.hasOwnProperty(b) && (d[b] = a[b]);
  if (c && c.defaultProps)
    for (b in a = c.defaultProps, a)
      d[b] === void 0 && (d[b] = a[b]);
  return { $$typeof: g, type: c, key: e, ref: l, props: d, _owner: m.current };
}
reactJsxRuntime_production_min.jsx = q;
reactJsxRuntime_production_min.jsxs = q;
{
  jsxRuntime.exports = reactJsxRuntime_production_min;
}
const jsx = jsxRuntime.exports.jsx;
const EditableSpan = ({
  id,
  value
}) => {
  const {
    caret,
    focus,
    dispatch,
    props: {
      readOnly,
      spanStyle,
      spanClassName
    }
  } = useStore();
  const ref = useRef(null);
  const held = useHeldCaret(ref);
  focus.useManualFocus(id, ref);
  useRestoredFocus(caret, ref);
  const handleInput = (e) => {
    var _a;
    held();
    const newValue = (_a = e.currentTarget.textContent) != null ? _a : "";
    dispatch(Type.Change, {
      key: id,
      value: newValue
    });
  };
  const handlePaste = (e) => {
    e.preventDefault();
    const text = e.clipboardData.getData("text");
    document.execCommand("insertText", false, text);
  };
  return /* @__PURE__ */ jsx("span", {
    ref,
    style: spanStyle,
    className: spanClassName,
    contentEditable: !readOnly,
    suppressContentEditableWarning: true,
    onInput: handleInput,
    onFocus: () => focus.setFocused(id),
    onBlur: () => focus.setFocused(null),
    onPaste: handlePaste,
    children: value
  });
};
const SliceList = () => {
  const {
    sliceMap,
    props: _a
  } = useStore(), _b = _a, {
    Mark
  } = _b, props = __objRest(_b, [
    "Mark"
  ]);
  const handleKeyDown = useHandleKeyDown();
  const className = props.className ? DefaultClass + " " + props.className : DefaultClass;
  return /* @__PURE__ */ jsx("div", {
    className,
    style: props.style,
    onKeyDown: handleKeyDown,
    children: [...sliceMap].map(([key, value]) => isObject(value) ? /* @__PURE__ */ jsx(Mark, __spreadValues({
      tabIndex: -1
    }, value.props), key) : /* @__PURE__ */ jsx(EditableSpan, {
      id: key,
      value
    }, key))
  });
};
var style = "";
const useFocus = () => {
  const [focused, setFocused] = useState(null);
  const isTail = useRef(false);
  const useManualFocus = (id, ref) => useEffect(() => {
    if (id !== focused || !ref.current)
      return;
    if (isTail.current) {
      ref.current.focus();
      Caret.setCaretToEnd(ref.current);
      isTail.current = false;
      return;
    }
    ref.current.focus();
  }, [focused]);
  return {
    focused,
    setFocused,
    isTail,
    useManualFocus
  };
};
const useConfigs = (children) => useMemo(() => extractConfigs(children), [children]);
const useSliceMap = (props, configs) => {
  const slices = useSlicesOf(props.value);
  const state = useKeyMapperFor(slices);
  const dispatch = useDispatcher();
  return [state, dispatch];
  function useSlicesOf(text) {
    const [slices2, setSlices] = useState([]);
    useEffect(() => {
      const newSlices = slice(text, configs);
      setSlices(newSlices);
    }, [text]);
    return slices2;
    function slice(text2, configs2) {
      const regExp = getCombinedRegex();
      return iterateSlices();
      function getCombinedRegex() {
        const regExps = configs2.map((c) => markupToRegex(c.markup));
        return new RegExp(regExps.map((value) => value.source).join("|"));
      }
      function iterateSlices() {
        const result = [];
        let [span, mark, raw] = nextMatch(text2);
        while (mark && raw != null) {
          result.push(span, mark);
          [span, mark, raw] = nextMatch(raw);
        }
        result.push(span);
        return result;
      }
      function nextMatch(text3) {
        let match = regExp.exec(text3);
        if (!match)
          return [text3, null, null];
        let [span, mark, raw] = extractSlices(match);
        return [span, mark, raw];
      }
      function extractSlices(execArray) {
        const match = extractMatch(execArray);
        const mark = getMark(match);
        const span = match.input.substring(0, match.index);
        const raw = match.input.substring(match.index + match.annotation.length);
        return [span, mark, raw];
      }
      function extractMatch(execArray) {
        let annotation = execArray[0];
        let childIndex = 0;
        let value = execArray[1];
        let id = execArray[2];
        while (true) {
          if (value || id)
            break;
          childIndex++;
          value = execArray[2 * childIndex + 1];
          id = execArray[2 * childIndex + 2];
        }
        let index = execArray.index;
        let input = execArray.input;
        return { annotation, value, id, input, index, childIndex };
      }
      function getMark({ childIndex, id, value }) {
        const props2 = configs2[childIndex].initializer(value, id);
        return { id, value, props: props2, childIndex };
      }
    }
  }
  function useKeyMapperFor(slices2) {
    const [sliceMap, setSliceMap] = useState(() => /* @__PURE__ */ new Map());
    useEffect(() => {
      const newMap = slices2.reduce((map, slice) => map.set(genKey(slice, map), slice), /* @__PURE__ */ new Map());
      setSliceMap(newMap);
    }, [slices2.length]);
    return sliceMap;
    function genKey(slice, newMap) {
      let str = isObject(slice) ? slice.id + slice.value : slice;
      let seed = 0;
      let key = genHash(str, seed);
      while (newMap.has(key))
        key = genHash(str, seed++);
      return key;
    }
  }
  function useDispatcher() {
    return useCallback((type, payload) => {
      reducer(state, { type, payload });
      function reducer(state2, action) {
        switch (action.type) {
          case Type.Change:
            const { key, value = "" } = action.payload;
            state2.set(key, value);
            props.onChange(toString([...state2.values()], configs));
            break;
          case Type.Delete:
            state2.delete(action.payload.key);
            props.onChange(toString([...state2.values()], configs));
            break;
          default:
            throw new Error();
        }
      }
    }, [state]);
  }
};
const useMarkedInput = (props) => {
  const caret = useCaret();
  const focus = useFocus();
  const configs = useConfigs(props.children);
  const [sliceMap, dispatch] = useSliceMap(props, configs);
  return {
    caret,
    focus,
    configs,
    props,
    sliceMap,
    dispatch
  };
};
const MarkedInput = (props) => {
  const store = useMarkedInput(props);
  return /* @__PURE__ */ jsx(StoreProvider, {
    value: store,
    children: /* @__PURE__ */ jsx(SliceList, {})
  });
};
const Option = (props) => null;
function styleInject(css,ref){if(ref===void 0){ref={}}var insertAt=ref.insertAt;if(!css||typeof document==="undefined"){return}var head=document.head||document.getElementsByTagName("head")[0];var style=document.createElement("style");style.type="text/css";if(insertAt==="top"){if(head.firstChild){head.insertBefore(style,head.firstChild)}else{head.appendChild(style)}}else{head.appendChild(style)}if(style.styleSheet){style.styleSheet.cssText=css}else{style.appendChild(document.createTextNode(css))}};styleInject(`.marked-input {
}
.marked-input span {
    outline: none;
    white-space: pre-wrap;
}

`);
export { MarkedInput, Option };
