import { PLACEHOLDER } from "./constants";
import { ReactElement } from "react";
import { OptionProps } from "./Option";
import { MarkedInputProps } from "./MarkedInput";
import { Caret } from "./hooks/useCaret";
import { Focus } from "./hooks/useFocus";
export declare type Mark<T> = {
    id: string;
    value: string;
    props: T;
    childIndex: number;
};
declare type id = `${string}${PLACEHOLDER.Id}${string}`;
declare type value = `${string}${PLACEHOLDER.Value}${string}`;
export declare type Markup = `${value}${id}` | `${value}`;
export declare type PassedOptions<T> = ReactElement<OptionProps<T>> | ReactElement<OptionProps<T>>[];
export declare type Configs<T> = OptionProps<T>[];
export declare type Slice<T> = string | Mark<T>;
export declare type SliceMap<T> = Map<number, Slice<T>>;
export declare type Match = {
    annotation: string;
    id: string;
    value: string;
    index: number;
    input: string;
    childIndex: number;
};
export declare type Store = {
    props: MarkedInputProps<any>;
    configs: Configs<any>;
    caret: Caret;
    focus: Focus;
    sliceMap: SliceMap<any>;
    dispatch: Dispatch;
};
export declare type Dispatch = (type: Type, payload: Payload) => void;
export declare enum Type {
    Change = 0,
    Delete = 1
}
export declare type Action = {
    type: Type;
    payload: Payload;
};
export declare type Payload = {
    key: number;
    value?: Slice<any>;
};
export {};
//# sourceMappingURL=types.d.ts.map